package cn.com.qmth.stmms.ms.core.repository;

import cn.com.qmth.stmms.ms.core.domain.ChangeLevelTask;
import cn.com.qmth.stmms.ms.core.domain.MarkStage;
import cn.com.qmth.stmms.ms.core.vo.Subject;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

@Repository
public interface ChangeLevelTaskRepo extends JpaRepository<ChangeLevelTask, Long>, JpaSpecificationExecutor {

    @Query(value = "SELECT count(1) from change_level_task m inner join paper p on m.paper_id = p.id and p.is_missing = ?4 and p.is_shift = 1 where p.question_id = ?1 and m.marker_id = ?2 and m.stage = ?3 and m.confirm_change_stage = false", nativeQuery = true)
    Integer countShiftByQuestionIdAndMarkerIdAndStageAndIsMissing(Long questionId, Long markerId, int stage, boolean isMissing);

    int countByPaperIdAndSubjectAndStageAndConfirmChangeStage(Long paperId, String subject, MarkStage stage, boolean confirmChangeStage);

    void deleteByWorkIdAndSubjectAndStage(Long workId, String subject, MarkStage stage);

    @Modifying
    @Query("update ChangeLevelTask m set m.isMark = ?2 where m.id = ?1")
    void updateMarkTaskMarkById(Long markTaskId, Boolean isMark);
}
