package cn.com.qmth.stmms.ms.marking.assembler;

import cn.com.qmth.stmms.ms.core.domain.MarkStage;
import cn.com.qmth.stmms.ms.core.repository.MarkTaskLevelRepo;
import cn.com.qmth.stmms.ms.core.repository.MarkTaskRoughLevelRepo;
import cn.com.qmth.stmms.ms.core.repository.MarkTaskScoreRepo;
import cn.com.qmth.stmms.ms.core.vo.Subject;
import cn.com.qmth.stmms.ms.marking.dto.MarkQuestionStatDTO;
import cn.com.qmth.stmms.ms.marking.dto.QuestionStatDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * Created by zhengmin on 2016/10/14.
 */
@Component
public class QuestionStatAssembler {

    @Autowired
    private MarkTaskRoughLevelRepo markTaskRoughLevelRepo;

    @Autowired
    private MarkTaskLevelRepo markTaskLevelRepo;

    @Autowired
    private MarkTaskScoreRepo markTaskScoreRepo;

    public QuestionStatDTO toDTO(Object[] qStats) {
        return this.assemble(qStats);
    }

    public QuestionStatDTO toDTOWithMarkers(Object[] qStats) {
        QuestionStatDTO qpDTO = this.assemble(qStats);
        if (qpDTO != null) {

        }
        return qpDTO;
    }

    private QuestionStatDTO assemble(Object[] qStats) {
        QuestionStatDTO qpDTO = null;
        if (qStats != null) {
            qpDTO = new QuestionStatDTO();
            qpDTO.setId(qStats[0]);
            qpDTO.setName(qStats[1]);
            qpDTO.setLeftCount(qStats[2]);
            qpDTO.setTotalCount(qStats[3]);
            qpDTO.setAreaCode(qStats[4]);
        }
        return qpDTO;
    }

    public QuestionStatDTO toProgressDTO(Object[] qStats) {
        QuestionStatDTO qpDTO = null;
        if (qStats != null) {
            qpDTO = new QuestionStatDTO();
            qpDTO.setAreaCode(qStats[0]);
            qpDTO.setAreaName(qStats[1]);
            qpDTO.setName(qStats[2]);
            qpDTO.setLeftCount(qStats[3]);
            qpDTO.setTotalCount(qStats[4]);
        }
        return qpDTO;
    }


    public MarkQuestionStatDTO toMarkProgressDTO(Object[] qStats, Long workId, Subject subject, MarkStage stage) {

        int shift = 0;
        int shiftScore = 0;
        int rejectCount =0;
        if (MarkStage.ROUGH_LEVEL.equals(stage)) {
            //所有打回
            rejectCount = markTaskRoughLevelRepo.findByWorkIdAndSubjectAndMarkerIdAndStageReject(workId, subject.name(), Long.valueOf(qStats[0].toString()), MarkStage.ROUGH_LEVEL.ordinal());
        } else if (MarkStage.LEVEL.equals(stage)) {
            // 改粗档，打细档
            shift = markTaskRoughLevelRepo.countByWorkIdAndSubjectAndMarkerIdAndStageAndShiftAndResult(workId, subject.name(), Long.valueOf(qStats[0].toString()), MarkStage.LEVEL.ordinal());
            shiftScore = markTaskLevelRepo.countByWorkIdAndSubjectAndMarkerIdAndStageAndShiftScoreAndResult(workId, subject.name(), Long.valueOf(qStats[0].toString()), MarkStage.LEVEL.ordinal());
            //所有打回
            rejectCount = markTaskLevelRepo.findByWorkIdAndSubjectAndMarkerIdAndStageReject(workId, subject.name(), Long.valueOf(qStats[0].toString()), MarkStage.LEVEL.ordinal());
        } else if (MarkStage.SCORE.equals(stage)) {
            // 打细档，打分
            shift = markTaskLevelRepo.countByWorkIdAndSubjectAndMarkerIdAndStageAndShiftAndResult(workId, subject.name(), Long.valueOf(qStats[0].toString()), MarkStage.SCORE.ordinal());
            shiftScore = markTaskScoreRepo.countByWorkIdAndSubjectAndMarkerIdAndStageAndShiftScoreAndResult(workId, subject.name(), Long.valueOf(qStats[0].toString()), MarkStage.SCORE.ordinal());
        }

        MarkQuestionStatDTO qpDTO = new MarkQuestionStatDTO();
        qpDTO.setLoginName(qStats[1]);
        qpDTO.setMarkerName(qStats[2]);
        qpDTO.setLeftCount(qStats[3]);
        qpDTO.setTotalCount(qStats[4]);
        qpDTO.setRejectedCount(rejectCount);
        qpDTO.setShiftCount(shift);
        qpDTO.setShiftScoreCount(shiftScore);
        return qpDTO;
    }
}
